OpenTTD Source: RoadStopPickerCallbacks< roadstoptype > Class Template Reference

OpenTTD Source 15.0-beta1

Public Member Functions | Static Public Member Functions
RoadStopPickerCallbacks< roadstoptype > Class Template Reference
Inheritance diagram for RoadStopPickerCallbacks< roadstoptype >:

## Public Member Functions
| RoadStopPickerCallbacks (const std::string &ini_group)
StringID | GetClassTooltip () const override
| Get the tooltip string for the class list.
StringID | GetTypeTooltip () const override
| Get the tooltip string for the type grid.
bool | IsActive () const override
| Should picker class/type selection be enabled?
bool | HasClassChoice () const override
| Are there multiple classes to chose from?
int | GetSelectedClass () const override
| Get the index of the selected class.
void | SetSelectedClass (int id) const override
| Set the selected class.
StringID | GetClassName (int id) const override
| Get the name of a class.
int | GetSelectedType () const override
| Get the selected type.
void | SetSelectedType (int id) const override
| Set the selected type.
StringID | GetTypeName (int cls_id, int id) const override
| Get the item of a type.
bool | IsTypeAvailable (int cls_id, int id) const override
| Test if an item is currently buildable.
void | DrawType (int x, int y, int cls_id, int id) const override
| Draw preview image of an item.
void | FillUsedItems (std::set< PickerItem > &items) override
| Fill a set with all items that are used by the current player.
StringID | GetClassTooltip () const
| Get the tooltip string for the class list.
StringID | GetTypeTooltip () const
| Get the tooltip string for the type grid.
StringID | GetClassTooltip () const
| Get the tooltip string for the class list.
StringID | GetTypeTooltip () const
| Get the tooltip string for the type grid.
Public Member Functions inherited from PickerCallbacksNewGRFClass< RoadStopClass >
| PickerCallbacksNewGRFClass (const std::string &ini_group)
T::index_type | GetClassIndex (int cls_id) const
const RoadStopClass * | GetClass (int cls_id) const
const T::spec_type * | GetSpec (int cls_id, int id) const
int | GetClassCount () const override
| Get the number of classes.
int | GetTypeCount (int cls_id) const override
| Get the number of types in a class.
PickerItem | GetPickerItem (const typename T::spec_type *spec, int cls_id=-1, int id=-1) const
PickerItem | GetPickerItem (int cls_id, int id) const override
| Get data about an item.
std::set< PickerItem > | UpdateSavedItems (const std::set< PickerItem > &src) override
| Update link between grfid/localidx and class_index/index in saved items.
Public Member Functions inherited from PickerCallbacks
| PickerCallbacks (const std::string &ini_group)
virtual void | Close (int)

## Static Public Member Functions
static bool | IsClassChoice (const RoadStopClass &cls)

## Additional Inherited Members
Data Fields inherited from PickerCallbacks
Listing | class_last_sorting = { false, 0 }
| Default sorting of PickerClassList.
Filtering | class_last_filtering = { false, 0 }
| Default filtering of PickerClassList.
Listing | type_last_sorting = { false, 0 }
| Default sorting of PickerTypeList.
Filtering | type_last_filtering = { false, 0 }
| Default filtering of PickerTypeList.
const std::string | ini_group
| Ini Group for saving favourites.
uint8_t | mode = 0
| Bitmask of `PickerFilterModes`.
std::set< PickerItem > | used
| Set of items used in the current game by the current company.
std::set< PickerItem > | saved
| Set of saved favourite items.

## Detailed Description

template<RoadStopType roadstoptype>
class RoadStopPickerCallbacks< roadstoptype >

Definition at line 1179 of file road_gui.cpp.

## Constructor & Destructor Documentation

## ◆ RoadStopPickerCallbacks()

template<RoadStopType roadstoptype>

RoadStopPickerCallbacks< roadstoptype >::RoadStopPickerCallbacks | ( | const std::string & | ini_group | ) |
| inline

Definition at line 1181 of file road_gui.cpp.

## Member Function Documentation

## ◆ DrawType()

template<RoadStopType roadstoptype>

void RoadStopPickerCallbacks< roadstoptype >::DrawType | ( | int | x,
|  | int | y,
|  | int | cls_id,
|  | int | id
| ) |  | const
| inlineoverridevirtual

Draw preview image of an item.

Implements PickerCallbacks.

Definition at line 1236 of file road_gui.cpp.

References DIAGDIR_END, HasBit(), INVALID_RAILTYPE, RoadStopPickerSelection::orientation, ROADSTOP_BUS, and RSF_DRIVE_THROUGH_ONLY.

## ◆ FillUsedItems()

template<RoadStopType roadstoptype>

void RoadStopPickerCallbacks< roadstoptype >::FillUsedItems | ( | std::set< PickerItem > & | items | ) |
| inlineoverridevirtual

Fill a set with all items that are used by the current player.

Implements PickerCallbacks.

Definition at line 1248 of file road_gui.cpp.

References _local_company, FACIL_BUS_STOP, FACIL_TRUCK_STOP, SpecializedStation< Station, false >::Iterate(), ROADSTOP_BUS, ROADSTOP_CLASS_DFLT, ROADSTOP_TRUCK, ROADSTOPTYPE_ALL, ROADSTOPTYPE_FREIGHT, and ROADSTOPTYPE_PASSENGER.

## ◆ GetClassName()

template<RoadStopType roadstoptype>

StringID RoadStopPickerCallbacks< roadstoptype >::GetClassName | ( | int | id | ) | const
| inlineoverridevirtual

Get the name of a class.

Implements PickerCallbacks.

Definition at line 1213 of file road_gui.cpp.

References INVALID_STRING_ID.

## ◆ GetClassTooltip() [1/3]

StringID RoadStopPickerCallbacks< ROADSTOP_BUS >::GetClassTooltip | ( |  | ) | const
| virtual

Get the tooltip string for the class list.

Implements PickerCallbacks.

Definition at line 1265 of file road_gui.cpp.

## ◆ GetClassTooltip() [2/3]

StringID RoadStopPickerCallbacks< ROADSTOP_TRUCK >::GetClassTooltip | ( |  | ) | const
| virtual

Get the tooltip string for the class list.

Implements PickerCallbacks.

Definition at line 1268 of file road_gui.cpp.

## ◆ GetClassTooltip() [3/3]

template<RoadStopType roadstoptype>

StringID RoadStopPickerCallbacks< roadstoptype >::GetClassTooltip | ( |  | ) | const
| overridevirtual

Get the tooltip string for the class list.

Implements PickerCallbacks.

## ◆ GetSelectedClass()

template<RoadStopType roadstoptype>

int RoadStopPickerCallbacks< roadstoptype >::GetSelectedClass | ( |  | ) | const
| inlineoverridevirtual

Get the index of the selected class.

Implements PickerCallbacks.

Definition at line 1210 of file road_gui.cpp.

References RoadStopPickerSelection::sel_class.

## ◆ GetSelectedType()

template<RoadStopType roadstoptype>

int RoadStopPickerCallbacks< roadstoptype >::GetSelectedType | ( |  | ) | const
| inlineoverridevirtual

Get the selected type.

Implements PickerCallbacks.

Definition at line 1220 of file road_gui.cpp.

References RoadStopPickerSelection::sel_type.

## ◆ GetTypeName()

template<RoadStopType roadstoptype>

StringID RoadStopPickerCallbacks< roadstoptype >::GetTypeName | ( | int | cls_id,
|  | int | id
| ) |  | const
| inlineoverridevirtual

Get the item of a type.

Implements PickerCallbacks.

Definition at line 1223 of file road_gui.cpp.

References INVALID_STRING_ID, and ROADSTOP_BUS.

## ◆ GetTypeTooltip() [1/3]

StringID RoadStopPickerCallbacks< ROADSTOP_BUS >::GetTypeTooltip | ( |  | ) | const
| virtual

Get the tooltip string for the type grid.

Implements PickerCallbacks.

Definition at line 1266 of file road_gui.cpp.

## ◆ GetTypeTooltip() [2/3]

StringID RoadStopPickerCallbacks< ROADSTOP_TRUCK >::GetTypeTooltip | ( |  | ) | const
| virtual

Get the tooltip string for the type grid.

Implements PickerCallbacks.

Definition at line 1269 of file road_gui.cpp.

## ◆ GetTypeTooltip() [3/3]

template<RoadStopType roadstoptype>

StringID RoadStopPickerCallbacks< roadstoptype >::GetTypeTooltip | ( |  | ) | const
| overridevirtual

Get the tooltip string for the type grid.

Implements PickerCallbacks.

## ◆ HasClassChoice()

template<RoadStopType roadstoptype>

bool RoadStopPickerCallbacks< roadstoptype >::HasClassChoice | ( |  | ) | const
| inlineoverridevirtual

Are there multiple classes to chose from?

Reimplemented from PickerCallbacksNewGRFClass< RoadStopClass >.

Definition at line 1205 of file road_gui.cpp.

References NewGRFClass< Tspec, Tindex, Tmax >::Classes().

## ◆ IsActive()

template<RoadStopType roadstoptype>

bool RoadStopPickerCallbacks< roadstoptype >::IsActive | ( |  | ) | const
| inlineoverridevirtual

Should picker class/type selection be enabled?

Implements PickerCallbacks.

Definition at line 1186 of file road_gui.cpp.

References NewGRFClass< Tspec, Tindex, Tmax >::Classes(), IsWaypointClass(), ROADSTOP_BUS, ROADSTOP_TRUCK, ROADSTOPTYPE_ALL, ROADSTOPTYPE_FREIGHT, and ROADSTOPTYPE_PASSENGER.

## ◆ IsClassChoice()

template<RoadStopType roadstoptype>

static bool RoadStopPickerCallbacks< roadstoptype >::IsClassChoice | ( | const RoadStopClass & | cls | ) |
| inlinestatic

Definition at line 1200 of file road_gui.cpp.

## ◆ IsTypeAvailable()

template<RoadStopType roadstoptype>

bool RoadStopPickerCallbacks< roadstoptype >::IsTypeAvailable | ( | int | cls_id,
|  | int | id
| ) |  | const
| inlineoverridevirtual

Test if an item is currently buildable.

Implements PickerCallbacks.

Definition at line 1230 of file road_gui.cpp.

References IsRoadStopAvailable(), and ROADSTOP_BUS.

## ◆ SetSelectedClass()

template<RoadStopType roadstoptype>

void RoadStopPickerCallbacks< roadstoptype >::SetSelectedClass | ( | int | id | ) | const
| inlineoverridevirtual

Set the selected class.

Implements PickerCallbacks.

Definition at line 1211 of file road_gui.cpp.

References RoadStopPickerSelection::sel_class.

## ◆ SetSelectedType()

template<RoadStopType roadstoptype>

void RoadStopPickerCallbacks< roadstoptype >::SetSelectedType | ( | int | id | ) | const
| inlineoverridevirtual

Set the selected type.

Implements PickerCallbacks.

Definition at line 1221 of file road_gui.cpp.

References RoadStopPickerSelection::sel_type.

The documentation for this class was generated from the following file:

- src/road_gui.cpp